      program geometry_plt
      parameter(nch=24,nsht0=999)
      real x_shot(nsht0),x_sta(nch,nsht0),x_cmp(nch*2-3,nsht0)
      character filen*80,com1*80,cdum(nsht0)*12
      filen='./maswkf/prm/geometry.prm'
      open(11,file=filen,status='old')
      read(11,'(a45)')com1
      write(6,'(a45)')com1
      read(11,*)nsht,dx   !:Number of shots,dx(geophone interval) 
      write(6,*)nsht,dx
      dd=dx/4.
      dd=1.
c shot and geophone locations
      do isht=1,nsht
       read(11,*) cdum(isht),x_shot(isht),x_sta(1,isht)
       write(6,*) cdum(isht),x_shot(isht),x_sta(1,isht)
       do ich=2,nch
        x_sta(ich,isht)=real(ich-1)*dx+x_sta(1,isht)
       enddo
      enddo
      close(11)
c CMP locations
      do isht=1,nsht
       x_cmp(1,isht)=x_sta(1,isht)+dx/2.
       do icmp=2,2*nch-3
        x_cmp(icmp,isht)=x_cmp(1,isht)+real(icmp-1)*dx/2.
       enddo
      enddo
c
      filen='./maswkf/data/geometry/x_shot.dat'
      open(11,file=filen,status='unknown')
c shot point
      do isht=1,nsht
       write(11,'(f8.1,a1,f8.3)')x_shot(isht),',',(isht-0)*dd
      enddo
      close(11)
c cmp
      filen='./maswkf/data/geometry/x_cmp.dat'
      open(11,file=filen,status='unknown')
      do isht=1,nsht
       do icmp=1,2*nch-3
        write(11,'(f8.1,a1,f8.3)')x_cmp(icmp,isht),',',(isht-0)*dd
       enddo
      enddo
      close(11)
c geophones
      filen='./maswkf/data/geometry/x_sta.dat'
      open(11,file=filen,status='unknown')
      do isht=1,nsht
       do ich=1,nch
        write(11,'(f8.1,a1,f8.3)')x_sta(ich,isht),',',(isht-0)*dd
       enddo
      enddo
      close(11)
c graphic output using GNUPLOT
      filen='./maswkf/prm/gnuplt_script/geometry.plt'
      write(6,*)filen
      write(6,*)com1
      open(12,file=filen,status='unknown')
      write(12,*)'reset'
      write(12,*)'unset key'
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:45)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Distance along the measurement line (m)"'
      write(12,*)'set xrange [',x_shot(1),':',x_sta(nch,nsht),']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "Shot Number"'
      write(12,*)'set yrange [0:',real(nsht),']'
      write(12,*)'set multiplot'
      write(12,*)'plot "./maswkf/data/geometry/x_sta.dat"'//
     *                       ' with points pt  6 ps .3 lc rgb "red"'
      write(12,*)'plot "./maswkf/data/geometry/x_cmp.dat"'//
     *                       ' with points pt  6 ps .1 lc rgb "blue"'
      write(12,*)'plot "./maswkf/data/geometry/x_shot.dat"'//
     *                       ' with points pt 11 ps .7 lc rgb "black"'
      write(12,*)'unset multiplot'
      write(12,*)'set terminal postscript color enhanced'
      write(12,*)
     *     'set output "./maswkf/data/geometry/fig/geometry.ps"'
      write(12,*)'reset'
      write(12,*)'unset key'
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:45)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Distance along the measurement line (m)"'
      write(12,*)'set xrange [',x_shot(1),':',x_sta(nch,nsht),']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "Shot Number"'
      write(12,*)'set yrange [0:',real(nsht),']'
      write(12,*)'set multiplot'
      write(12,*)'plot "./maswkf/data/geometry/x_sta.dat"'//
     *                       ' with points pt  6 ps .3 lc rgb "red"'
      write(12,*)'plot "./maswkf/data/geometry/x_cmp.dat"'//
     *                       ' with points pt  6 ps .1 lc rgb "blue"'
      write(12,*)'plot "./maswkf/data/geometry/x_shot.dat"'//
     *                       ' with points pt 11 ps .7 lc rgb "black"'
      write(12,*)'unset multiplot'

      write(12,*)'set output'
      write(12,*)'set terminal wxt'
c
      stop
      end
