c seg2read
c
c  Input File Name Convention
c   nflg1=1: files created by GEODE & PICKWIN95
c     sxbg8026.sg2
c     8 characters for the name and '.sg2' for the extention that indicates seg2 format
c     7th and 8th characters indicate the numbering of measurements
c   nflg1=0: files created by DaqLinkIII
c     001.sg2
c     3 characters for the name and '.sg2' for the extention that indicates seg2 format
c  Output File Name Convention 
c   For output to a multi-channel files of nch component
c   nflg2=0: Only the extention is replaced
c     sxbg8026.dat
c     001.dat
c   For output to nch cdm files of single component
c   nflg2=1
c     sxbg802601.cdm (for nflg1=0)
c     9th and 10th characters indicate the numbering of channels
c          00101.cdm (for nflg1=1)
c     4th and 5th characters indicate the numbering of channels
c
      parameter(nch0=48,nn0=300000)
      real*8    xx(nn0,nch0)
      character filen*80,filen1*80,cdum*80,cdd*15,cname*9,cnam*4,
     *          c_ext*4,cform2*15,comment*80
c common blocks
      COMMON /FLAGS/n_geode
      COMMON /FACTOR/descale
      data kiban/1/ 
c scale factor: Input data are divided by this scale factor
c	data scale/1.e6/
c parameters to control input files' name
c      data nflg1,nflg2/1,1/
c	data cname/'./sxbg80'/ 
c	data ifiles,ifilee/24,25/ 
	c_ext='.sg2'
	n_c_ext=4
c file created by GEODE (=1): Format of File & Trace discriptor blocks are different from SG2
c Control file
      open(10,file='./maswkf/prm/seg2read.prm',status='old')
c     read(10,*)nflg1,nflg2
      nflg1=1
      nflg2=0
      read(10,'(a6)')cname
      read(10,*)ifiles,ifilee
      read(10,*)scale,gain
      kch=1
      read(10,*)mch
      read(10,'(a80)')comment
      close(10)
      write(6,*)cname,ifiles,ifilee
c file following the SG2 format (=0)
      n_geode=nflg1
c
      do ifile=ifiles,ifilee
       if(nflg1.eq.0) then
c       write(6,*)'Processing for files created by DaqLinkIII'
c       write(6,*)'Processing for files of correct seg2 format'
        n_cname=6
        n_filen=10
        if(ifile.lt.10) then
         n_ifile=1
         write(cnam,'(i1)')ifile
         filen='../00'//cnam(1:n_ifile)//c_ext(1:n_c_ext)
        else if(ifile.lt.100) then
           n_ifile=2
         write(cnam,'(i2)')ifile
         filen='../0'//cnam(1:n_ifile)//c_ext(1:n_c_ext)
        else
         n_ifile=3
         write(cnam,'(i3)')ifile
         filen='../'//cnam(1:n_ifile)//c_ext(1:n_c_ext)
        endif
       else if(nflg1.eq.1) then
c       write(6,*)'Processing for files created by PickWin95 & GEODE'
        n_cname=6
        n_filen=12
        if(ifile.lt.10) then
	   n_ifile=1
         write(cnam,'(i1)')ifile
         filen=cname(1:n_cname)//'0'//cnam(1:n_ifile)//c_ext(1:n_c_ext)
	  else if(ifile.lt.100) then
	   n_ifile=2
         write(cnam,'(i2)')ifile
         filen=cname(1:n_cname)//cnam(1:n_ifile)//c_ext(1:n_c_ext)
        endif
       endif
       filen='./maswkf/data/field_data/'//filen
       n_filen=n_filen+25
       write(6,*)'Read Input file:',filen(26:n_filen),':'
       filen1=filen(1:n_filen)
c
c
c
c
c

	 call seg2read(xx,nch,nn,nch0,nn0,filen,kiban,dt)
c
c        write(6,*)'descale=',descale
c
c
c
c
c
       write(6,*) ' nch=',nch,' kch=',kch,' mch=',mch,
     *            ' dt=',dt,' nn=',nn
       filen=filen1
c 
       if(scale.le.1.e-12) then
        write(6,*)
     *  ' Descaling factor=',descale/1000.,'(V/digit) is used.'
        if(abs(descale).gt.1.e-12) then        
         scale=1./(descale/1000.)
        else
         scale=1.
        endif
       endif
       if(gain.gt.1.e-12) then
        scale=scale*gain
       endif
c
       if(nflg2.eq.0) then
        if(nch.ge.10) then
         write(cform2,'(a7,i2,a6)')'(f12.6,',nch,'e15.7)'
        else if(nch.ge.3) then
         write(cform2,'(a7,1x,i1,a6)')'(f12.6,',nch,'e15.7)'
        else
         write(6,*)'nch should be bigger than 2!'
        endif
c output to multi channel file
        filen1='./maswkf/data/common_shot_gathers/'
     *                              //filen1(26:n_filen-4)//'.dat'
        write(6,*)'Output to :',filen1(35:n_filen+9)
        open(2,file=filen1,status='unknown')
        write(2,'(i8,f8.5,i8,e16.3)')nch,dt,nn,scale
        do ich=kch,mch
         write(2,'(i12)')ich
         write(2,'(6e13.6)')(xx(i,ich)/scale,i=1,nn)
        enddo
cc
c        if(gain.le.1.e-12) then
c         write(2,*)mch-kch+1,dt,scale,nn,'         V      '
c        else
c         write(2,*)mch-kch+1,dt,scale,nn,'         V/(m/s)'
c        endif
c        write(2,'(a80)')comment
c        do i=1,nn
c         write(2,cform2)real(i-1)*dt,(xx(i,ich)/scale,ich=kch,mch)
c        enddo
cc
        close(2)
       else if(nflg2.eq.1) then
c output to cdm files (1ch in each file)
        do ich=kch,mch
         if(nflg1.eq.0) then
	    if(ich.lt.10) then
	     write(filen1,'(a6,a1,i1,a4)') filen(1:6),'0',ich,'.cdm'
	    else
	     write(filen1,'(a6,i2,a4)') filen(1:6),ich,'.cdm'
          endif
         else if(nflg1.eq.1) then
          if(ich.lt.10) then
	   write(filen1,'(a3,a3,a1,i1,a4)')
     *              filen(1:3),filen(6:8),'0',ich,'.cdm'
          else
           write(filen1,'(a3,a3,i2,a4)')
     *              filen(1:3),filen(6:8),ich,'.cdm'
          endif
         endif
         write(6,*)'To ',filen1
         open(2,file=filen1,status='unknown')
         write(2,'(a6,a12,a7,i2)')' File=',filen1(4:15),'    ch.',ich
         write(2,'(24x,a4)')'unit'
         write(2,'(24X,a4)') ' V  '
         do i=1,nn
          tt=real(i-1)*dt
          ttsec=tt-int(tt/60.)*60.
          nttmin=mod(int(tt/60.),60)
          ntthour=int(int(tt/60.)/60)
          write(cdum,'(i8,a7,f6.3)')i-1,' 00:00:',ttsec
          if(ttsec.lt.1.0) then
           write(cdum(16:17),'(a2)') '00'
	    else if(ttsec.lt.10.) then
           write(cdum(16:16),'(a1)') '0'
		endif
          if(nttmin.lt.10) then
	     write(cdum(13:14),'(a1,i1)')'0',nttmin
	    else if(nttmin.ge.10) then
	     write(cdum(13:14),'(i2)')nttmin
	    endif
          if(ntthour.lt.10) then
	     write(cdum(10:11),'(a1,i1)')'0',ntthour
	    else if(ntthour.ge.10) then
	     write(cdum(10:11),'(i2)')ntthour
	    endif
c          write(cdd,'(f15.5)')xx(i,ich)/scale
          write(cdd,'(e15.7)')xx(i,ich)/scale
c         cdd=adjustl(cdd)
c          do iadjustl=1,15
c           if(cdd(1:1).eq.' ') then
c            cdd=cdd(2:15)
c           endif
c          enddo
          write(2,'(a21,1x,a15)')cdum(1:21),cdd
	   enddo 
        enddo
c
       endif
      enddo
c
      stop
      end
ccccc
	subroutine seg2read(xx,nch,nn,nch0,nn0,filen,kbn,dt)
c xx(nn,nch): output array of data
c nch       : number of trace (output)
c nn        : number of samples per trace (output)
c nch0,nn0  : declared array size
c filen     : input file name (SEG2 format)
c kbn       : kiban(unit number) allocated to the input file
c
c l_kbn     : kiban(unit number) allocated to the log file (6 means console)
c
c Made by Toshiaki Yokoi (IISEE, BRI, Japan), APR. 19, 2011.
      real*8  xx(nn0,nch0),fraction
      integer*8 ix(0:4095)
      integer*8 revnum,pointerbytecount,numtrace,
     *        stringtermcount,stringterm1,stringterm2,linetermcount,
     *        lineterm1,lineterm2,tracepointers(96),
     *        blockleng,datalength,numsamples,datatype,w_kbn,
     *        string_file_len,string_trace_len,n(0:49),nnn
      character filen*80,cx(0:4095)*1,string_file*1000,
     *          string_trace*1000,s(0:49)*30,cform*80 
      character cdate*11,ctime*8,camp_recovery*80,client*80,
     *          company*80,cinstrument*80,cline_id*80,cobserver*80,
     *          cpdate*11,cptime*8,crawrecord*80,creciever*80,
     *          creciever_specs*80,csource*80,ct_sort*80,cunits*10,
     *          cnote*200,cnote1*200,ct_type*80
c common blocks
      COMMON /FLAGS/n_geode
      COMMON /FACTOR/descale
      data w_kbn/6/ nnn/256_8/
c     data l_kbn/10/
      data n/0,16,16,12,18,18,10,9,14,6,7,5,5,16,26,23,22,12,10,
     *       16,15,10,6,7,14,15,8,8,15,15,10,9,17,17,14,23,15,
     *        20,4,7,15,15,21,5,18,10,10,5,4,7/
      data s/'','ACQUISITION_DATE','ACQUISITION_TIME','ALIAS_FILTER',
     *       'AMPLITUDE_RECOVERY','BAND_REJECT_FILTER','CDP_NUMBER',
     *       'CDP_TRACE','CHANNEL_NUMBER','CLIENT',
     *       'COMPANY','DATUM','DELAY','DESCALING_FACTOR',
     *       'DIGITAL_BAND_REJECT_FILTER','DIGITAL_HIGH_CUT_FILTER',
     *       'DIGITAL_LOW_CUT_FILTER','END_OF_GROUP','FIXED_GAIN',
     *       'GENERAL_CONSTANT','HIGH_CUT_FILTER','INSTRUMENT',
     *       'JOB_ID','LINE_ID','LOW_CUT_FILTER',
     *       'NOTCH_FREQUENCY','OBSERVER','POLARITY',
     *       'PROCESSING_DATE','PROCESSING_TIME','RAW_RECORD',
     *       'RECEIVER ','RECEIVER_GEOMETRY','RECEIVER_LOCATION',
     *   'RECEIVER_SPECS','RECEIVER_STATION_NUMBER','SAMPLE_INTERVAL',
     *       'SHOT_SEQUENCE_NUMBER','SKEW','SOURCE ',
     *    'SOURCE_GEOMETRY','SOURCE_LOCATION','SOURCE_STATION_NUMBER',
     *       'STACK','STATIC_CORRECTIONS','TRACE_SORT',
     *       'TRACE_TYPE','UNITS','NOTE','       '/
      s(49)=char(78)//char(0)//char(79)//char(0)//char(84)
     *                                 //char(0)//char(69)
      open(kbn,file=filen,access='direct',recl=4,form='unformatted')
c read File Descriptor Block
c     write(6,*)'read File Descriptor Block'
      do i=1,32,4
       i0=(i-1)/4+1
       read(kbn,rec=i0) (cx(i-1+ii),ii=0,3)
      enddo
      do ii=0,31
       ix(ii)=ichar(cx(ii))
      enddo
      if(ix(0).eq.58) then    ! 58=3ah
       write(w_kbn,*)'Byte reversed data not allowed.'	
       stop
      else if (ix(0).ne.85.or.ix(1).ne.58) then   ! 85=55h
       write(6,*)'File Descriptor Block'
       write(w_kbn,*)'Not SEG-2 data, can not continue',ix(0),ix(1)
       stop
      endif
c blockid=3a55h: PC==> 55h first (low byte first order) 
      revnum=ix(2)+ix(3)*256
c     write(l_kbn,'(a18,i3)')' revision number =',revnum
      pointerbytecount=ix(4)+ix(5)*256
c      write(l_kbn,'(a34,i3)')
c     *    ' Size of Trace Pointer Sub-block =',pointerbytecount
      numtrace=ix(6)+ix(7)*256
c      write(l_kbn,'(a32,i3)')' Number of traces in this file =',
c     *                                              numtrace
      stringtermcount=ix(8)
c     write(l_kbn,'(a28,i3)')
c    *              ' Size of String Terminator =',stringtermcount
      stringterm1=ix(9)
      if(stringtermcount.eq.1) then
       if(stringterm1.eq.0) then
c       write(l_kbn,'(a30,a3)')' String Terminator Character =','00h'
       else
c       write(l_kbn,'(a30,i3)')' String Terminator Character ='
c    *                                                      ,stringterm1
       endif
      else if(stringtermcount.eq.2) then
       stringterm2=ix(10)
c      write(l_kbn,'(a40,2i3)')
c	*   ' 1st & 2nd String Terminator Character ='
c    *                     ,stringterm1,stringterm2
      endif
      linetermcount=ix(11)
c     write(l_kbn,'(a26,i4)')' Size of Line Terminator =',linetermcount
      lineterm1=ix(12)
      if(linetermcount.eq.1) then
       if(lineterm1.eq.10) then			 ! 10=1Ah "Line Feed"
c       write(l_kbn,'(a28,a2)')' Line Terminator Character =','LF'
       else if(lineterm1.eq.13) then		 ! 13=1Dh "Caridge Return"
c       write(l_kbn,'(a28,a2)')' Line Terminator Character =','CR'
       else
c       write(l_kbn,'(a28,i3)')' Line Terminator Character =',lineterm1
       endif
      else if(linetermcount.eq.2) then
       lineterm2=ix(13)
c      write(l_kbn,'(a38,2i4)')' 1st & 2nd Line Terminator Character =',
c    *                    lineterm1,lineterm2
      endif
c Byte 14 - 31 are reserved and then skipped.
c read trace pointer sub-block
c     write(6,*)'read trace pointer sub-block'
      do i=33,36+(4*(numtrace-1)),4
       i0=(i-1)/4+1
       read(kbn,rec=i0) (cx(i-33+ii),ii=0,3)
	enddo
      do ii=0,95
       ix(ii)=ichar(cx(ii))
	enddo
      do i=33,36+(4*(numtrace-1)),4
	 i0=(i-1)/4+1
c       write(l_kbn,*)i0-8,(ix(i-33+ii),ii=0,3)
       j=i-33
       tracepointers(i0-8)=
     *          ix(j)+ix(j+1)*256+ix(j+2)*256**2+ix(j+3)*nnn**4
      enddo
c read Strings. Length is (tracepointers(1)-pointerbytecount-32)/4 bytes
      do i=1,(tracepointers(1)-pointerbytecount-32)/4
	 i0=8+numtrace+i
       read(kbn,rec=i0) (cx(4*(i-1)+ii),ii=0,3)
	enddo
      do ii=0,tracepointers(1)-pointerbytecount-33
       ix(ii)=ichar(cx(ii))
      enddo																	    
c	write(l_kbn,*)(ix(ii),ii=0,tracepointers(1)-pointerbytecount-33)
c	write(l_kbn,*)
c     *  (char(ix(ii)),ii=0,tracepointers(1)-pointerbytecount-33)
c It was detected that Geode files do not follow exactly SEG2 format 
c for Strings in File Descriptor Blcok. String is empty.
      do ii=0,tracepointers(1)-pointerbytecount-33
	 string_file(ii+1:ii+2)=char(ix(ii))
      enddo
      string_file_len=tracepointers(1)-pointerbytecount-32
c     write(l_kbn,*)string_file(1:string_file_len)
c read Trace Descriptor Block
c      write(6,*)'read Trace Descriptor Block'
      do ich=1,numtrace
c       write(l_kbn,'(a16,i2,a3,i8)')
c     *       ' Trace pointers(',ich,') =',tracepointers(ich)
       i0=tracepointers(ich)/4
       do i=1,8
        read(kbn,rec=i0+i)(cx(4*(i-1)+ii),ii=0,3)
       enddo
       do ii=0,31
        ix(ii)=ichar(cx(ii))
       enddo
       if(ix(0).eq.68.and.ix(1).eq.34) then    ! 34=22h,68=44h
        write(w_kbn,*)'Byte reversed data not allowed.'	
        stop
       else if (ix(0).ne.34.or.ix(1).ne.68) then   ! 68=44h
        write(6,*)'Trace Descriptor Block'
        write(w_kbn,*)'Not SEG-2 data can not continue',ix(0),ix(1)
        stop
       endif
c      write(l_kbn,*)(ix(ii),ii=0,3)
       blockleng=ix(2)+ix(3)*256
c      write(l_kbn,'(a34,i2,a2,i4)')
c    *   ' Size of Trace Descriptor Block ( ',1,')=',blockleng
c      write(l_kbn,*)(ix(ii+4),ii=0,3)
       datalength=ix(4)+ix(5)*256+ix(6)*256**2+ix(7)*nnn**4
c      write(l_kbn,'(a35,i8)')
c    *              ' Size of Corresponding Data Block =',datalength
c      write(l_kbn,*)(ix(ii+8),ii=0,3)
       numsamples=ix(8)+ix(9)*256+ix(10)*256**2+ix(11)*nnn**4
c      write(l_kbn,'(a34,i8)')
c    *               ' Number of Samples in Data Block =',numsamples
       datatype=ix(12)
c      write(l_kbn,'(a19,i8)')' Data Format Code =',datatype
       if(datatype.eq.1) then
c       write(l_kbn,'(19x,a22)')':16bit fixed point.   '
       else if(datatype.eq.2) then
c       write(l_kbn,'(19x,a22)')':32bit fixed point.   '
       else if(datatype.eq.3) then
c       write(l_kbn,'(19x,a22)')':20bit fixed point.   '
       else if(datatype.eq.4) then
c       write(l_kbn,'(19x,a22)')':32bit floating point.'
       else if(datatype.eq.5) then
c       write(l_kbn,'(19x,a22)')':64bit floating point.'
       else
c       write(w_kbn,'(a10,i1,a18)')' Data Type', datatype,
c    *                         ' is not available.' 
        stop
       endif 
c Byte 13-31 are reserved and then skipped.
c       write(l_kbn,'(i8)') blockleng,blockleng-32
c read Strings. Length is blockleng-32 bytes
       do i=1,(blockleng-32)/4
        read(kbn,rec=i0+8+i)(cx(4*(i-1)+ii),ii=0,3)
	 enddo
c	 write(l_kbn,*)(cx(ii),ii=0,blockleng-33)
       do ii=0,blockleng-33
        ix(ii)=ichar(cx(ii))
       enddo																	    
c	write(l_kbn,*)(char(ix(ii)),ii=0,blockleng-33)
      do ii=0,blockleng-33
	 string_trace(ii+1:ii+2)=char(ix(ii))
      enddo
      string_trace_len=blockleng-32
c     write(l_kbn,*)string_trace(1:string_trace_len)
c read data block
c      write(6,*)'read data block'
       if(datatype.eq.1)      then  ! 16bit fixed point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       else if(datatype.eq.2) then  ! 32bit fixed point
        do i=1,numsamples 
         read(kbn,rec=i0+blockleng/4+i)(cx(ii),ii=0,3)
         do ii=0,3
          ix(ii)=ichar(cx(ii))
         enddo
c        write(l_kbn,*)i,ix(3)/128,(ix(ii),ii=3,0,-1)
         if(ix(3).lt.128) then	  ! Positive value
          xx(i,ich)
     *    =dble( mod(ix(3),128)*256**3+ix(2)*256**2+ix(1)*256+ix(0) )
         else if(ix(3).ge.128) then ! Negative value
          xx(i,ich)
     *	=dble(-nnn**4+ix(3)*256**3+ix(2)*256**2+ix(1)*256+ix(0))
         endif
        enddo
       else if(datatype.eq.3) then  ! 20bit floating point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       else if(datatype.eq.4) then  ! 32bit floating point
        do i=1,numsamples 
         read(kbn,rec=i0+blockleng/4+i)(cx(ii),ii=0,3)
         do ii=0,3
          ix(ii)=ichar(cx(ii))
         enddo
         if(ix(3).lt.128) then
          n_sign=0
         else if(ix(3).ge.128) then
          n_sign=1
         endif
c       write(l_kbn,*)i,ix(3)/128,(ix(ii),ii=3,0,-1)
         n_exponent=mod(ix(3),128)*2+ix(2)/128
	   n_fraction=mod(ix(2),128)*256**2+ix(1)*256+ix(0)
         fraction=1.D0+dble(n_fraction)/dble(256**3)
         xx(i,ich)
     *   =dble((-1)**n_sign)*fraction*2.**dble(n_exponent-127)
        enddo
       else if(datatype.eq.5) then  !  64 bit floating point
        write(w_kbn,*)' This data type is not available yet.',datatype
        stop
       endif
      enddo
c======S
c
c     write(6,*)'Interpretation of File Discriptor Block'
c	write(6,*)'& Trace Discriptor Block is skipped.'
c     go to 999
c
c======E
	nch=numtrace
	nn =numsamples
c Interpretation of strings. Note that Geode files do not follow exactly 
c SEG2 format for strings. Strings do not start with the offset to the 
c next string. They start	with two continuous "00h" and end with the string
c terminator that is "00h".
c The string 'NOTE' included in the file descriptor block starts without 
c '00h'.Moreover the strings that should be included in the file descriptor 
c block are stored in the trace descriptor block, e. g., ACQUISITION_DATE etc.
c
c strings of file desriptor blocks
c      write(6,*)' strings of file desriptor blocks'
c
        ist=0
	kkn=0
	kks=1
	kkss=1
   98 if(kks.ge.49.or.kkss.ge.49) goto 190
      do kk=kks,49
       do ii=1,string_file_len-n(kk)+1
        if(string_file(ii:ii+n(kk)-1).eq.s(kk)(1:n(kk))) then
         ist=ii
         kkn=kk
         goto 100
        endif
       enddo
      enddo
  100 continue
c================================================================================
c It is necessary to modify the following sentences case by case.
      if(n_geode.eq.1) then  ! For files created by PickWin95 from GEODE files
       do ii=ist+n(kkn)-1,string_file_len-2
        if(string_file(ii:ii+2).eq.char(0)//char(0)//char(0)) then
         ied=ii-1
         goto 101
        endif
       enddo
  101  n_rest=ied-ist-n(kkn)
	else if(n_geode.eq.0) then ! For files created by DaqLinkIII
	 read(string_file(ist-2:ist-2),'(a1)') filen(1:1)
       n_rest=ichar(filen(1:1))-3-n(kkn)
  102  ied=ist+n(kkn)+n_rest-1
      endif
c================================================================================
      write(cform,'(a2,i3,a1)')'(a',n_rest,')'
c     write(l_kbn,*)
c    *           kkn,n(kkn),ist,ied,string_file(ist:ied),n_rest,cform
      if(kkn.lt.10) then
       if(kkn.eq.1) then                     ! 1 'ACQUISITION_DATE', cdate*11
	  read(string_file(ied-n_rest+1:ied),cform) cdate
c       write(l_kbn,*)string_file(ist:ied),' ',cdate
       else if(kkn.eq.2) then                ! 2 'ACQUISITION_TIME', ctime*8
	  read(string_file(ied-n_rest+1:ied),cform) ctime
c	  write(l_kbn,*)string_file(ist:ied),' ',ctime
       else if(kkn.eq.9) then                ! 9 'CLIENT'	,client*80
	  read(string_file(ied-n_rest+1:ied),cform) client
c       write(l_kbn,*)string_file(ist:ied),' ',client 
       endif
      else if(kkn.lt.20) then
       if(kkn.eq.10) then                     ! 10 'COMPANY',company*80
	  read(string_file(ied-n_rest+1:ied),cform) company
c       write(l_kbn,*)string_file(ist:ied),' ',company 
       else if(kkn.eq.19) then                ! 19 'GENERAL_CONSTANT'
	  read(string_file(ied-n_rest+1:ied),*) g_const
c       write(l_kbn,*)string_file(ist:ied),' ',g_const      
       endif
      else if(kkn.lt.30) then
       if(kkn.eq.21) then                     ! 21 'INSTRUMENT',cinstrument*80
	  read(string_file(ied-n_rest+1:ied),cform) cinstrument
c       write(l_kbn,*)string_file(ist:ied),' ',cinstrument 
       else if(kkn.eq.22) then                ! 22 'JOB_ID'
 	  read(string_file(ied-n_rest+1:ied),cform) filen
        read(filen,*) job_id
c       write(l_kbn,*)string_file(ist:ied),' ',job_id 
       else if(kkn.eq.26) then                ! 26 'OBSERVER',cobserver*80
	  read(string_file(ied-n_rest+1:ied),cform) cobserver
c       write(l_kbn,*)string_file(ist:ied),' ',cobserver 
       else if(kkn.eq.28) then                ! 28 'PROCESSING_DATE',cpdate*11
	  read(string_file(ied-n_rest+1:ied),cform) cpdate
c	  write(l_kbn,*)string_file(ist:ied),' ',cpdate
       else if(kkn.eq.29) then                ! 29 'PROCESSING_TIME',cptime*8
	  read(string_file(ied-n_rest+1:ied),cform) cptime
c	  write(l_kbn,*)string_file(ist:ied),' ',cptime
       endif
      else if(kkn.lt.50) then
       if(kkn.eq.45) then                      ! 45 'TRACE_SORT',ct_sort*80
	  read(string_file(ied-n_rest+1:ied),cform) ct_sort
c	  write(l_kbn,*)string_file(ist:ied),' ',ct_sort
       else if(kkn.eq.47) then                ! 47 'UNITS',cunits*10
	  read(string_file(ied-n_rest+1:ied),cform) cunits
c	  write(l_kbn,*)string_file(ist:ied),' ',cunits
       else if(kkn.eq.48) then                ! 48 'NOTE',cnote*200
        if(n_rest.le.0) then
         cnote='                                    '
        else
	   read(string_file(ied-n_rest+1:ied),cform) cnote
        endif
c        write(l_kbn,*)string_file(ist:ied),' ',cnote
       else if(kkn.eq.49) then                ! 49 'N O T E',cnote1*200
        if(n_rest.le.0) then
         cnote1='                                    '
        else
        read(string_file(ied-n_rest+1:ied),cform) cnote1
        endif
c        write(l_kbn,*)string_file(ist:ied),' ',cnote1
       endif
      else
       stop
      endif
      kks=kkn+1
      kkss=kkss+1
      goto 98
  190 continue
c
c strings of the trace descriptor blocks
c      write(6,*)' strings of the trace descriptor blocks'
c Current one read only the last trace's one: numtrace=24 ==> 24 ch
c                                                      12 ==> 12 ch
c
        ist=0
	kkn=0
	kks=1
	kkss=1
  198 if(kks.ge.49.or.kkss.ge.49) goto 290
      do kk=kks,49
       do ii=1,string_trace_len-n(kk)+1
        if(string_trace(ii:ii+n(kk)-1).eq.s(kk)(1:n(kk))
     *     .and.string_trace(ii-3:ii-3).eq.char(0)) then
c	write(6,*)string_trace(ii:ii+n(kk)-1)
         ist=ii
         kkn=kk
         goto 200
        endif
       enddo
      enddo
  200 continue
c================================================================================
c Modified Dec.26,2013.
      if(n_geode.eq.1) then 
       read(string_trace(ist-2:ist-2),'(a1)') filen(1:1)
c      write(6,*)ist,ichar(filen(1:1))
       if(ichar(filen(1:1)).ge.n(kkn)+3) then ! standard string terminators case
        n_rest=ichar(filen(1:1))-3-n(kkn)
        ied=ist+n(kkn)+n_rest-1
       else                                   ! string terminator "00 00 00"
        do ii=ist+n(kkn)-1,string_trace_len-2
         if(string_trace(ii:ii+2).eq.char(0)//char(0)//char(0)) then
          ied=ii-1
          goto 201
         endif
        enddo
  201   n_rest=ied-ist-n(kkn)
       endif
      endif
c     write(6,*)ist,n(kkn),ied
c     write(6,*)'check 201',string_trace,n_rest,ied
c================================================================================
      write(cform,'(a2,i3,a1)')'(a',n_rest,')'
c      write(l_kbn,*)
c     *           kkn,n(kkn),ist,ied,string_trace(ist:ied),n_rest,cform
      if(kkn.lt.10) then
       if(kkn.eq.1) then                     ! 1 'ACQUISITION_DATE', cdate*11
	  read(string_trace(ied-n_rest+1:ied),cform) cdate
c	  write(l_kbn,*)string_trace(ist:ied),' ',cdate
       else if(kkn.eq.2) then                ! 2 'ACQUISITION_TIME', ctime*8
	  read(string_trace(ied-n_rest+1:ied),cform) ctime
c       write(l_kbn,*)string_trace(ist:ied),' ',ctime 
       else if(kkn.eq.3) then                ! 3 'ALIAS_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) alf_freq,alf_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',alf_freq,alf_slope
       else if(kkn.eq.4) then                ! 4 'AMPLITUDE_RECOVERY',camp_recovery*80
	  read(string_trace(ied-n_rest+1:ied),cform) camp_recovery
c         write(6,*)cform,camp_recovery
c       write(l_kbn,*)string_trace(ist:ied),' ',camp_recovery
       else if(kkn.eq.5) then                ! 5 'BAND_REJECT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                              br_lp_fr,br_lp_sl,br_hp_fr,br_hp_sl
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                              br_lp_fr,br_lp_sl,br_hp_fr,br_hp_sl
       else if(kkn.eq.6) then                ! 6 'CDP_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*) n_cdp
c       write(l_kbn,*)string_trace(ist:ied),' ',n_cdp
       else if(kkn.eq.7) then                ! 7 'CDP_TRACE'
	  read(string_trace(ied-n_rest+1:ied),cform)filen
	  read(filen,*) n_cdp_trace
c       write(l_kbn,*)string_trace(ist:ied),' ',n_cdp_trace
       else if(kkn.eq.8) then                ! 8 'CHANNEL_NUMBER'
        read(string_trace(ied-n_rest+1:ied),cform)filen
        read(filen,*) n_channel
c       write(l_kbn,*)string_trace(ist:ied),' ',n_channel
       else if(kkn.eq.9) then                ! 9 'CLIENT'	,client*80
	  read(string_trace(ied-n_rest+1:ied),cform) client
c        write(l_kbn,*)string_trace(ist:ied),' ',client 
       endif
      else if(kkn.lt.20) then
       if(kkn.eq.10) then                     ! 10 'COMPANY',company*80
	  read(string_trace(ied-n_rest+1:ied),cform) company
c       write(l_kbn,*)string_trace(ist:ied),' ',company 
       else if(kkn.eq.11) then                ! 11 'DATUM'
	  read(string_trace(ied-n_rest+1:ied),cform)filen
	  read(filen,*) datum
c       write(l_kbn,*)string_trace(ist:ied),' ',datum
       else if(kkn.eq.12) then                ! 12 'DELAY'
	  read(string_trace(ied-n_rest+1:ied),*) delay
c       write(l_kbn,*)string_trace(ist:ied),' ',delay
       else if(kkn.eq.13) then                ! 13 'DESCALING_FACTOR'
	  read(string_trace(ied-n_rest+1:ied),*) descale
c       write(l_kbn,*)string_trace(ist:ied),' ',descale
       else if(kkn.eq.14) then                ! 14 'DIGITAL_BAND_REJECT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                          dbr_lp_fr,dbr_lp_sl,dbr_hp_fr,dbr_hp_sl
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                          dbr_lp_fr,dbr_lp_sl,dbr_hp_fr,dbr_hp_sl
       else if(kkn.eq.15) then                ! 15 'DIGITAL_HIGH_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) dhc_freq,dhc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',dhc_freq,dhc_slope
       else if(kkn.eq.16) then                ! 16 'DIGITAL_LOW_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) dlc_freq,dlc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',dlc_freq,dlc_slope
       else if(kkn.eq.17) then                ! 17 'END_OF_GROUP'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*)nd_of_group
c       write(l_kbn,*)string_trace(ist:ied),' ',nd_of_group
       else if(kkn.eq.18) then                ! 18 'FIXED_GAIN'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*)nfgain
c       write(l_kbn,*)string_trace(ist:ied),' ',nfgain
       else if(kkn.eq.19) then                ! 19 'GENERAL_CONSTANT'
	  read(string_trace(ied-n_rest+1:ied),*) g_const
c       write(l_kbn,*)string_trace(ist:ied),' ',g_const      
       endif
      else if(kkn.lt.30) then
	 if(kkn.eq.20) then                     ! 20 'HIGH_CUT_FILTER'
c       write(6,*)string_trace(ist:ied),ist,ied
	  read(string_trace(ied-n_rest+1:ied),*) hc_freq,hc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',hc_freq,hc_slope
       else if(kkn.eq.21) then                ! 21 'INSTRUMENT',cinstrument*80
	  read(string_trace(ied-n_rest+1:ied),cform) cinstrument
c       write(l_kbn,*)string_trace(ist:ied),' ',cinstrument 
       else if(kkn.eq.22) then                ! 22 'JOB_ID'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) job_id
c       write(l_kbn,*)string_trace(ist:ied),' ',job_id      
	 else if(kkn.eq.23) then                ! 23 'LINE_ID',cline_id*80
	  read(string_trace(ied-n_rest+1:ied),cform) cline_id
c       write(l_kbn,*)string_trace(ist:ied),' ',cline_id 
       else if(kkn.eq.24) then                ! 24 'LOW_CUT_FILTER'
	  read(string_trace(ied-n_rest+1:ied),*) lc_freq,lc_slope
c       write(l_kbn,*)string_trace(ist:ied),' ',lc_freq,lc_slope
       else if(kkn.eq.25) then                ! 25 'NOTCH_FREQUENCY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) an_fr
c       write(l_kbn,*)string_trace(ist:ied),' ',an_fr      
       else if(kkn.eq.26) then                ! 26 'OBSERVER',cobserver*80
	  read(string_trace(ied-n_rest+1:ied),cform) cobserver
c       write(l_kbn,*)string_trace(ist:ied),' ',cobserver 
       else if(kkn.eq.27) then                ! 27 'POLARITY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_polarity
c       write(l_kbn,*)string_trace(ist:ied),' ',n_polarity      
       else if(kkn.eq.28) then                ! 28 'PROCESSING_DATE',cpdate*11
	  read(string_trace(ied-n_rest+1:ied),cform) cpdate
c	  write(l_kbn,*)string_trace(ist:ied),' ',cpdate
       else if(kkn.eq.29) then                ! 29 'PROCESSING_TIME',cptime*8
	  read(string_trace(ied-n_rest+1:ied),cform) cptime
c	  write(l_kbn,*)string_trace(ist:ied),' ',cptime
       endif
      else if(kkn.lt.40) then
	 if(kkn.eq.30) then                     ! 30 'RAW_RECORD',crawrecord*80
	  read(string_trace(ied-n_rest+1:ied),cform) crawrecord
c	  write(l_kbn,*)string_trace(ist:ied),' ',crawrecord
       else if(kkn.eq.31) then                ! 31 'RECEIVER ',creciever*80
	  read(string_trace(ied-n_rest+1:ied),cform) creciever
c	  write(l_kbn,*)string_trace(ist:ied),' ',creciever
       else if(kkn.eq.32) then                ! 32 'RECEIVER_GEOMETRY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) r_geometry
c       write(l_kbn,*)string_trace(ist:ied),' ',r_geometry      
       else if(kkn.eq.33) then                ! 33 'RECEIVER_LOCATION'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*)r_location
c        write(l_kbn,*)string_trace(ist:ied),' ',r_location      
       else if(kkn.eq.34) then                ! 34 'RECEIVER_SPECS',creciever_specs*80
	  read(string_trace(ied-n_rest+1:ied),cform) creciever_specs
c	  write(l_kbn,*)string_trace(ist:ied),' ',creciever_specs
       else if(kkn.eq.35) then                ! 35 'RECEIVER_STATION_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_rstn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_rstn      
       else if(kkn.eq.36) then                ! 36 'SAMPLE_INTERVAL'
	  read(string_trace(ied-n_rest+1:ied),*) dt
c       write(l_kbn,*)string_trace(ist:ied),' ',dt      
c       write(6,*)string_trace(ist:ied),' ',dt      
       else if(kkn.eq.37) then                ! 37 'SHOT_SEQUENCE_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_ssn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_ssn      
       else if(kkn.eq.38) then                ! 38 'SKEW'
	  read(string_trace(ied-n_rest+1:ied),*) skew
c       write(l_kbn,*)string_trace(ist:ied),' ',skew      
       else if(kkn.eq.39) then                ! 39 'SOURCE ',csource*80
	  read(string_trace(ied-n_rest+1:ied),cform) csource
c       write(l_kbn,*)string_trace(ist:ied),' ',csource      
       endif
      else if(kkn.lt.50) then
	 if(kkn.eq.40) then                     ! 40 'SOURCE_GEOMETRY'
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) s_geometry
c       write(l_kbn,*)string_trace(ist:ied),' ',s_geometry      
       else if(kkn.eq.41) then                ! 41 'SOURCE_LOCATION'
	  read(string_trace(ied-n_rest+1:ied),*) s_location
c       write(l_kbn,*)string_trace(ist:ied),' ',s_location
       else if(kkn.eq.42) then                ! 42 'SOURCE_STATION_NUMBER'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_sstn
c       write(l_kbn,*)string_trace(ist:ied),' ',n_sstn      
       else if(kkn.eq.43) then                ! 43 'STACK'
	  read(string_trace(ied-n_rest+1:ied),cform) filen
        read(filen,*) n_stack
c       write(l_kbn,*)string_trace(ist:ied),' ',n_stack      
       else if(kkn.eq.44) then                ! 44 'STATIC_CORRECTIONS'
	  read(string_trace(ied-n_rest+1:ied),*) 
     *                              s_st_correct,r_st_correct,st_correct
c       write(l_kbn,*)string_trace(ist:ied),' ',
c    *                              s_st_correct,r_st_correct,st_correct
       else if(kkn.eq.45) then                ! 45 'TRACE_SORT',ct_sort*80
	  read(string_trace(ied-n_rest+1:ied),cform) ct_sort
c	  write(l_kbn,*)string_trace(ist:ied),' ',ct_sort
       else if(kkn.eq.46) then                ! 46 'TRACE_TYPE',ct_type
 	  read(string_trace(ied-n_rest+1:ied),cform) filen
	  read(filen,*)ct_type
c       write(l_kbn,*)string_trace(ist:ied),' ',ct_type      
       else if(kkn.eq.47) then                ! 47 'UNITS',cunits*10
	  read(string_trace(ied-n_rest+1:ied),cform) cunits
c	  write(l_kbn,*)string_trace(ist:ied),' ',cunits
       else if(kkn.eq.48) then                ! 48 'NOTE',cnote*200
        if(n_rest.le.0) then
         cnote='                                    '
        else
	   read(string_trace(ied-n_rest+1:ied),cform) cnote
        endif
c       write(l_kbn,*)string_trace(ist:ied),' ',cnote
       else if(kkn.eq.49) then                ! 49 'N O T E',cnote1*200
        if(n_rest.le.0) then
         cnote1='                                    '
        else
	   read(string_trace(ied-n_rest+1:ied),cform) cnote1
        endif
c       write(l_kbn,*)string_trace(ist:ied),' ',cnote1
       endif
      else
       stop
      endif
	kks=kkn+1
	kkss=kkss+1
	goto 198
  290 continue
c
  999 continue
c
	close(kbn)
	if(w_kbn.ne.6) close(w_kbn)
      return
	end
ccccc
