      program disp_comb
      parameter(nn0=4096,ncmp0=500)
      real fr(nn0,ncmp0),vr(nn0,ncmp0)
      integer n_fr(ncmp0)
      character filen*80,cfile(ncmp0)*12,cfrm*15,cform*15,cfr1*28
      character cdrv*2,cwkf*9,com1*45
      data cdrv/'./'/              ! ciform/ '(4e20.12)'/
c      character cdrv*3,cwkf*10  
c      data cdrv/'../'/  
      write(6,*)'Program disp_comb.for'
c working folder name
      cwkf=cdrv//'maswkf/'
c parameter file
      filen='./maswkf/prm/'//'disp_comb.prm'
c      write(6,*)filen
      open(11,file=filen,status='old')
c     read(11,*)ncmp
      nn=500
c
      do icmp=1,10000
       read(11,'(a12)',end=20) cfile(icmp)
       filen='./maswkf/data/dispersion/'//cfile(icmp)
c       write(6,*)filen
       open(13,file=filen,status='unknown')
       read(13,*)                
       do i=1,nn
        read(13,*,end=10)fr(i,icmp),vr(i,icmp)
c        write(6,*)fr(i,icmp),vr(i,icmp)
       enddo
   10  n_fr(icmp)=i-1
       close(13)
      enddo
   20 ncmp=icmp-1
      close(11)
c
      fmin=fr(1,1)
      fmax=fr(n_fr(1),1)
      do icmp=2,ncmp
       if(fmin.gt.fr(1,icmp))          fmin=fr(1,icmp)
       if(fmax.lt.fr(n_fr(icmp),icmp)) fmax=fr(n_fr(icmp),icmp)
      enddo
      fmin=real(int(fmin))
      fmax=real(int(fmax)+1)
      vmin=1000.
      vmax=50.
      do icmp=1,ncmp
       do i=1,n_fr(icmp)
        if(vmin.gt.vr(i,icmp)) vmin=vr(i,icmp)
        if(vmax.lt.vr(i,icmp)) vmax=vr(i,icmp)
       enddo
      enddo
      if(vmin.ge.100.) vmin=100.
      write(6,*)vmin,vmax
      if(vmax.lt.200.)  vmax=200.
      if(vmax.gt.200..and.vmax.lt.400.) vmax=400.
      if(vmax.gt.400..and.vmax.lt.600.) vmax=600.
      if(vmax.gt.600..and.vmax.lt.800.) vmax=800.
      if(vmax.gt.500..and.vmax.lt.1000.) vmax=1000.
      if(vmax.gt.1000..and.vmax.lt.1500.) vmax=1500.
      if(vmax.gt.1500..and.vmax.lt.2000.) vmax=2000.
      write(6,*)vmin,vmax
c interim outout csv file for all cmp
      filen='./maswkf/data/dispersion/'//'disp_all.csv'
      write(6,*)filen
      open(13,file=filen,status='unknown')
      write(cform,'(a1,i3,a11)')'(',ncmp,'(a6,a6,a1))'
c     write(6,*)cform
      write(13,cform)('Freq.,',cfile(icmp)(1:6),',',icmp=1,ncmp)
c     write(6,cform) ('Freq.,',cfile(icmp)(1:6),',',icmp=1,ncmp)
c
      do icmp=1,ncmp
       if(icmp.eq.1) then
        write(cfr1,'(a1,a13,i3,a3)')'(','f8.3,a1,f4.0,',ncmp-1,'a2)'
       else if(icmp.eq.2) then
        write(cfr1,'(a1,a2,a14,i3,a3)')
     *                  '(','a2',',f8.3,a1,f4.0,',ncmp-2,'a2)'
       else if(ncmp-icmp.ge.2) then
        write(cfr1,'(a1,i3,a2,a14,i3,a3)')
     *           '(',icmp-1,'a2',',f8.3,a1,f4.0,',ncmp-icmp,'a2)'
       else if(ncmp-icmp.eq.1) then
        write(cfr1,'(a1,i3,a2,a14,a3)')
     *           '(',icmp-1,'a2',',f8.3,a1,f4.0,','a2)'
       else if(ncmp-icmp.eq.0) then
        write(cfr1,'(a1,i3,a2,a14)')
     *           '(',icmp-1,'a2',',f8.3,a1,f4.0)'
       endif
c      write(6,*)icmp,' ',cfr1
       do i=1,n_fr(icmp)
        write(13,cfr1)
     *   (',,',j=1,icmp-1),fr(i,icmp),',',vr(i,icmp),
     *                               (',,',j=1,ncmp-icmp)
       enddo
      enddo
      close(13)
c interim output txt file for all cmp
      filen='./maswkf/data/dispersion/'//'disp_all.dat'
      write(6,*)filen
      open(13,file=filen,status='unknown')
      do icmp=1,ncmp
       write(13,*)
       write(cfr1,'(a1,a13)')'(','f8.3,a1,f4.0)'
       write(13,'(a1,a6)')'#',cfile(icmp)(1:6)
       do i=1,n_fr(icmp)
        write(13,cfr1) fr(i,icmp),' ',vr(i,icmp)
       enddo
      enddo
      close(13)
c graphic output using GNUPLOT
      filen='./maswkf/prm/geometry.prm'
      open(11,file=filen,status='old')
      read(11,'(a45)')com1
      close(11)
      filen='./maswkf/prm/gnuplt_script/disp_all.plt'
      write(6,*)filen
      write(6,'(a45)')com1
      open(8,file=filen,status='unknown')
      write(8,*)'reset'
      write(8,*)'unset key'
      write(8,*)'# Graph title'
      write(8,*)'set title "'//com1(1:45)//' "'
      write(8,*)'# Horizontal axis: label & range'
      write(8,*)'set xlabel "Frequency (Hz)"'
      write(8,*)'set xrange [',fmin,':',fmax,']'
      write(8,*)'# Verical axis: label & range'
      write(8,*)'set ylabel "Phase Velocity (m/s)"'
      write(8,*)'set yrange [',vmin,':',vmax,']'
      write(8,*)'set multiplot'
      write(8,*)'plot "./maswkf/data/dispersion/disp_all.dat"'//
     *                    ' with lines lc rgb "blue"'
      write(8,*)'unset multiplot'
      write(8,*)'set terminal postscript color enhanced'
      write(8,*)
     *     'set output "./maswkf/data/dispersion/fig/disp_all.ps"'
      write(8,*)'reset'
      write(8,*)'unset key'
      write(8,*)'# Graph title'
      write(8,*)'set title "'//com1(1:45)//' "'
      write(8,*)'# Horizontal axis: label & range'
      write(8,*)'set xlabel "Frequency (Hz)"'
      write(8,*)'set xrange [',fmin,':',fmax,']'
      write(8,*)'# Verical axis: label & range'
      write(8,*)'set ylabel "Phase Velocity (m/s)"'
      write(8,*)'set yrange [',vmin,':',vmax,']'
      write(8,*)'set multiplot'
      write(8,*)'plot "./maswkf/data/dispersion/disp_all.dat"'//
     *                    ' with lines lc rgb "blue"'
      write(8,*)'unset multiplot'
      write(8,*)'set output'
      write(8,*)'set terminal wxt'
c
      do icmp=1,ncmp
       filen='./maswkf/prm/gnuplt_script/dispersion/disp'
     *                          //cfile(icmp)(4:6)//'.plt'
       write(6,*)filen
       open(12,file=filen,status='unknown')
       write(12,*)'set terminal postscript color enhanced'
       write(12,*)
     *  'set output "./maswkf/data/dispersion/fig/disp'
     *                           //cfile(icmp)(4:6)//'.ps"'
       write(12,*)'reset'
       write(12,*)'unset key'
       write(12,*)'# Graph title'
       write(12,*)'set title "'//com1(1:45)//cfile(icmp)(1:6)//' "'
       write(12,*)'# Horizontal axis: label & range'
       write(12,*)'set xlabel "Frequency (Hz)"'
       write(12,*)'set xrange [',fmin,':',fmax,']'
       write(12,*)'# Verical axis: label & range'
       write(12,*)'set ylabel "Phase Velocity (m/s)"'
       write(12,*)'set yrange [',vmin,':',vmax,']'
       write(12,*)'plot "./maswkf/data/dispersion/'//cfile(icmp)
     *        //'" with points lc rgb "red"'
       write(12,*)'set output'
       write(12,*)'set terminal wxt'
       close(12)
       write(8,*)
     *    'load ''./maswkf/prm/gnuplt_script/dispersion/disp',
     *                                    cfile(icmp)(4:6),'.plt'''
      enddo
      close(8)
c
      stop
      end
